/*
 * EsempioJDBC
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.sql.*;

public class EsempioJDBC extends JFrame {
    
    private JPanel mainPanel;
    private JPanel southPanel;
    
    private JScrollPane outputPane;
    private JTextArea output;
    private JLabel label;
    
    private JButton vacanze;
    private JButton partecipanti;   
    private JTextField tpartecipanti;
    
    
    public EsempioJDBC() {      
        
        mainPanel = new JPanel();
        southPanel = new JPanel();
        outputPane = new JScrollPane();
        vacanze= new JButton("Vacanze");
        partecipanti= new JButton("Partecipanti");
        tpartecipanti= new JTextField(20);  
        label = new JLabel("Visualizzazione Risultati");        
        output= new JTextArea();
        output.setEditable(false);
        
        mainPanel.setLayout(new BorderLayout());
        mainPanel.add(label,BorderLayout.NORTH);
        outputPane.setViewportView(output);
        mainPanel.add(outputPane,BorderLayout.CENTER);
        
        southPanel.add(vacanze);
        southPanel.add(partecipanti);
        southPanel.add(tpartecipanti);      
        mainPanel.add(southPanel,BorderLayout.SOUTH);
        
        getContentPane().add(mainPanel);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setTitle("JDBC Example");
        setLocation(50,20);
        setSize(800,600);
        
        setupEvents();      
    }
    
    private void setupEvents() {//setup eventi 
        ActionListener a=new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {               
                ascolta(evt);
            }
        };          
        vacanze.addActionListener(a);
        partecipanti.addActionListener(a);
    }
    
    private void ascolta(java.awt.event.ActionEvent e) {
        
        if (e.getActionCommand().compareTo("Vacanze")==0)   visualizzaVacanze();
        
        else if (e.getActionCommand().compareTo("Partecipanti")==0) {
            String vacanza=tpartecipanti.getText();
            visualizzaPartecipanti(vacanza);
        }
        
    }   
    
    private void visualizzaVacanze() {
        Connection conn = null;
        Statement st = null;
        ResultSet rs = null;
        try {
            conn = ConnectionManager.getConnection();
            if (conn != null)   {
                st = conn.createStatement();
                rs = st.executeQuery("SELECT descrizione " +
                    "FROM vacanza ");
                output.setText("LISTA DELLE VACANZE : \n");
                while (rs.next()) {
                    output.append(rs.getString("descrizione"));
                    output.append("\n");
                }
            }
         }
        catch (ClassNotFoundException e) { System.out.println("Driver NON TROVATO");}
        catch (SQLException e){ e.printStackTrace();} 
        finally {
          if(st != null) {
             try {
                  st.close();
                } catch(SQLException ce) { ce.printStackTrace();}  
            }
          if(conn != null) {
             try {                  
                  conn.close();
                } catch(SQLException ce) { ce.printStackTrace(); }  
            }
        
        }
        
    }
    
    private void visualizzaPartecipanti(String descVacanza){
        Connection conn = null;
        Statement st = null;
        ResultSet rs = null;
        try {
            conn = ConnectionManager.getConnection();
            if (conn != null)   {
                st = conn.createStatement();
                rs = st.executeQuery("SELECT vi.nome " +
                    "FROM villeggiante vi,vacanza va "+
                    "WHERE vi.vacanza=va.codice AND "+
                    "va.descrizione = '"+descVacanza+"'");
                output.setText("PARTECIPANTI ALLA VACANZA "+descVacanza+" :\n");
                while (rs.next()) {
                    output.append(rs.getString("nome"));
                    output.append("\n");
                }
            }            
        }
        catch (ClassNotFoundException e) { System.out.println("Driver NON TROVATO");}
        catch (SQLException e){ e.printStackTrace();} 
        finally {
          if(st != null) {
             try {
                  st.close();
                } catch(SQLException ce) { ce.printStackTrace();}  
            }
          if(conn != null) {
             try {                  
                  conn.close();
                } catch(SQLException ce) { ce.printStackTrace(); }  
            }
        
        }
        
    }
       
    public static void main(String args[])  {       
        EsempioJDBC frame = new EsempioJDBC();    
       frame.setVisible(true);     
    }
    
    
    
}
